stages:
  - test
  - build
  - deploy

minitest:
  stage: test
  image: node:18
  before_script:
    - npm i @nestjs/testing
  script:
    - npx jest
  except:
    - dev
    - main

linting:
  stage: test
  image: node:18
  script:
    - npm install --save-dev eslint @typescript-eslint/parser @typescript-eslint/eslint-plugin eslint-plugin-prettier eslint-config-prettier prettier
    - npm run lint
    - npm run format
  except:
    - dev
    - main

build_image:
  stage: build
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u tristetemps -p Developpement2003
  script: 
    - docker build -t tristetemps/lavireeterroirapi:lavireeterroirapi .
    - docker push tristetemps/lavireeterroirapi:lavireeterroirapi
  except:
    - main

deploy:
  stage: deploy
  image: ruby:3.1
  before_script:
    - chmod 600 $SSH_KEY
  script:
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@161.97.106.80 "
        docker login -u tristetemps -p Developpement2003 &&
        docker stop lavireeterroirapi || true &&
        docker rm lavireeterroirapi || true &&
        docker pull tristetemps/lavireeterroirapi:lavireeterroirapi &&
        docker run -d --name lavireeterroirapi -p 3000:3000 -e DATABASE_HOST=mysql-nest.alwaysdata.net -e DATABASE_USER=nest -e DATABASE_NAME=nest_lavireeterroir -e
        DATABASE_PASSWORD=Response2111 -e SECRET_KEY=VQH1YRXenCQ7SLVjRGJWzjplAnRReFvG -e MAIL_URL_TO_APP=https://lavireeterroir.fr tristetemps/lavireeterroirapi:lavireeterroirapi"
  only:
    - main
